package compbio.spring.security;

import org.springframework.security.core.GrantedAuthority;
import org.springframework.util.Assert;

/**
 * Maps groups defined in LDAP to roles for a specific user.
 */
/*
 * public enum PCacheLDAPAuthority implements GrantedAuthority { ROLE_LDAP_USER;
 * public String getAuthority() { return name(); } }
 */
public final class PCacheLDAPAuthority implements GrantedAuthority {

	private static final long serialVersionUID = 1;

	private String role = "ROLE_LDAP_USER";

	public PCacheLDAPAuthority(String role) {
		Assert.hasText(role, "A granted authority textual representation is required");
		this.role = role;
	}

	public String getAuthority() {
		return role;
	}

	public boolean equals(Object obj) {
		if (this == obj) {
			return true;
		}
		if (obj instanceof PCacheLDAPAuthority) {
			return role.equals(((PCacheLDAPAuthority) obj).role);
		}
		return false;
	}

	public int hashCode() {
		return this.role.hashCode();
	}

	public String toString() {
		return this.role;
	}
}
